var WebPagesReadOnlyActive = false;     // mjp:: single place to enable/disable read-only web pages capability [not yet fully implemented, shunted off for now...  20160908
var WebPagesVersionStr     = '0.004';   // increment this version number *every time* a change is made to js/css/html of the Blue Series pages

					// 0.004   changed JS [setInterval( myUpdateInputsThisPage, 1500);] Changed because HTTP request at 200 or 500 too fast.
					// 0.003:  responsive version. not approved as of 26 OCT 2016. Soon it will be approved
					// 0.002:  caching still occurs on IE... defeat all XmlHttpRequest.sends() with math. random!
                    //         add Jade Cloward's CSS so that system_status page need not put dashes in for disp of unit and loc


var RxDataEnums_PG_SystemStatus = 
{
    TemperatureZone_SetpointDegr_Idx_TANK       :       0,
    TemperatureZone_SetpointDegr_Idx_MANI       :       1,
    TemperatureZone_SetpointDegr_Idx_H1         :       2,
    TemperatureZone_SetpointDegr_Idx_G1         :       3,
    TemperatureZone_SetpointDegr_Idx_H2         :       4,
    TemperatureZone_SetpointDegr_Idx_G2         :       5,
    TemperatureZone_SetpointDegr_Idx_H3         :       6,
    TemperatureZone_SetpointDegr_Idx_G3         :       7,
    TemperatureZone_SetpointDegr_Idx_H4         :       8,
    TemperatureZone_SetpointDegr_Idx_G4         :       9,
    TemperatureZone_SetpointDegr_Idx_H5         :      10,
    TemperatureZone_SetpointDegr_Idx_G5         :      11,
    TemperatureZone_SetpointDegr_Idx_H6         :      12,
    TemperatureZone_SetpointDegr_Idx_G6         :      13,
    TemperatureZone_SetpointDegr_Idx_H7         :      14,
    TemperatureZone_SetpointDegr_Idx_G7         :      15,
    TemperatureZone_SetpointDegr_Idx_H8         :      16,
    TemperatureZone_SetpointDegr_Idx_G8         :      17,

    TemperatureZone_ActualValDegr_Idx_TANK      :      18+  0,
    TemperatureZone_ActualValDegr_Idx_MANI      :      18+  1,
    TemperatureZone_ActualValDegr_Idx_H1        :      18+  2,
    TemperatureZone_ActualValDegr_Idx_G1        :      18+  3,
    TemperatureZone_ActualValDegr_Idx_H2        :      18+  4,
    TemperatureZone_ActualValDegr_Idx_G2        :      18+  5,
    TemperatureZone_ActualValDegr_Idx_H3        :      18+  6,
    TemperatureZone_ActualValDegr_Idx_G3        :      18+  7,
    TemperatureZone_ActualValDegr_Idx_H4        :      18+  8,
    TemperatureZone_ActualValDegr_Idx_G4        :      18+  9,
    TemperatureZone_ActualValDegr_Idx_H5        :      18+ 10,
    TemperatureZone_ActualValDegr_Idx_G5        :      18+ 11,
    TemperatureZone_ActualValDegr_Idx_H6        :      18+ 12,
    TemperatureZone_ActualValDegr_Idx_G6        :      18+ 13,
    TemperatureZone_ActualValDegr_Idx_H7        :      18+ 14,
    TemperatureZone_ActualValDegr_Idx_G7        :      18+ 15,
    TemperatureZone_ActualValDegr_Idx_H8        :      18+ 16,
    TemperatureZone_ActualValDegr_Idx_G8        :      18+ 17,

    TemperatureUnits_Idx                        :      36,
    MelterStatus_BITMASK_Idx                    :      37,
    MelterStatus_ENUM_Idx                       :      38,
    MelterStatusAndAlarms_Idx                   :      39,
    HoursUntilNextService_Idx                   :      40,
    Pump2Present_Idx                            :      41,
    
    AutoStartEnabled_Idx                        :      42,
    Clock_D_Idx                                 :      43,
    Clock_H_Idx                                 :      44,
    Clock_M_Idx                                 :      45,

    BlueSeriesDevPresent_BITMASK_Idx            :      46,

    FlowMeterUsingEnglishUnits_Idx              :      47,
    FlowMeterAvgAdhPerTrig_mg_Idx               :      48,
    FlowMeterAdhVolume_grams_Idx                :      49,
    FlowMeterAdhVolume_TrigCount_Idx            :      50,

    NumItems                                    :      51,
};

var RxDataEnums_PG_SystemSetting = 
{
    ReadyInterlockDelay_Idx                     :       0,
    ServiceInterval_Idx                         :       1,
    MotorOffDelay_Idx                           :       2,
    AutoPumpOntemp_Idx                          :       3,
    AutoPump_Idx                                :       4,
    OverTempDelta_Idx                           :       5,
    UnderTempDelta_Idx                          :       6,
    StandbyDelta_Idx                            :       7,
    AutoStandbyTimeOut_Idx                      :       8,
    HeaterOffTimeOut_Idx                        :       9,
    ManualStandbyExit_Idx                       :      10,
    FillTimeDelay_Idx                           :      11,
    FillTimeLimit_Idx                           :      12,
    FillEnable_Idx                              :      13,
    ToteVibratorTime_Idx                        :      14,
    ActuatorCounts_Idx                          :      15,
    TemperatureUnit_Idx                         :      16,
    InputSetting_1_Idx                          :      17,
    InputSetting_2_Idx                          :      18,
    InputSetting_3_Idx                          :      19,
    InputSetting_4_Idx                          :      20,
    InputSetting_5_Idx                          :      21,
    InputSetting_6_Idx                          :      22,
    InputSetting_7_Idx                          :      23,
    InputSetting_8_Idx                          :      24,
    InputSetting_9_Idx                          :      25,
    InputSetting_10_Idx                         :      26,
    OutputSetting_1_Idx                         :      27,
    OutputSetting_2_Idx                         :      28,
    OutputSetting_3_Idx                         :      29,
    OutputSetting_4_Idx                         :      30,
    OutputSetting_5_Idx                         :      31,
    OutputSetting_6_Idx                         :      32,
    OutputSetting_7_Idx                         :      33,
    BlueSeriesDevPresent_BITMASK_Idx            :      34,
    
    NumItems                                    :      35,
};
    



var RxDataEnums_PG_History = 
{
    HeaterHrMeter_Idx                           :       0,
    TransactLog_Idx_TYPE_0                      :       (1 + (6*0)),
    TransactLog_Idx_DEVICE_0                    :       (2 + (6*0)),
    TransactLog_Idx_HOURS_0                     :       (3 + (6*0)),
    TransactLog_Idx_SRC_0                       :       (4 + (6*0)),
    TransactLog_Idx_PREV_0                      :       (5 + (6*0)),
    TransactLog_Idx_CURR_0                      :       (6 + (6*0)),
    TransactLog_Idx_TYPE_1                      :       (1 + (6*1)), 
    TransactLog_Idx_DEVICE_1                    :       (2 + (6*1)), 
    TransactLog_Idx_HOURS_1                     :       (3 + (6*1)), 
    TransactLog_Idx_SRC_1                       :       (4 + (6*1)), 
    TransactLog_Idx_PREV_1                      :       (5 + (6*1)), 
    TransactLog_Idx_CURR_1                      :       (6 + (6*1)), 
    TransactLog_Idx_TYPE_2                      :       (2 + (6*2)), 
    TransactLog_Idx_DEVICE_2                    :       (2 + (6*2)), 
    TransactLog_Idx_HOURS_2                     :       (3 + (6*2)), 
    TransactLog_Idx_SRC_2                       :       (4 + (6*2)), 
    TransactLog_Idx_PREV_2                      :       (5 + (6*2)), 
    TransactLog_Idx_CURR_2                      :       (6 + (6*2)), 
    TransactLog_Idx_TYPE_3                      :       (3 + (6*3)), 
    TransactLog_Idx_DEVICE_3                    :       (2 + (6*3)), 
    TransactLog_Idx_HOURS_3                     :       (3 + (6*3)), 
    TransactLog_Idx_SRC_3                       :       (4 + (6*3)), 
    TransactLog_Idx_PREV_3                      :       (5 + (6*3)), 
    TransactLog_Idx_CURR_3                      :       (6 + (6*3)), 
    TransactLog_Idx_TYPE_4                      :       (4 + (6*4)), 
    TransactLog_Idx_DEVICE_4                    :       (2 + (6*4)), 
    TransactLog_Idx_HOURS_4                     :       (3 + (6*4)), 
    TransactLog_Idx_SRC_4                       :       (4 + (6*4)), 
    TransactLog_Idx_PREV_4                      :       (5 + (6*4)), 
    TransactLog_Idx_CURR_4                      :       (6 + (6*4)), 
    TransactLog_Idx_TYPE_5                      :       (5 + (6*5)), 
    TransactLog_Idx_DEVICE_5                    :       (2 + (6*5)), 
    TransactLog_Idx_HOURS_5                     :       (3 + (6*5)), 
    TransactLog_Idx_SRC_5                       :       (4 + (6*5)), 
    TransactLog_Idx_PREV_5                      :       (5 + (6*5)), 
    TransactLog_Idx_CURR_5                      :       (6 + (6*5)), 
    TransactLog_Idx_TYPE_6                      :       (6 + (6*6)), 
    TransactLog_Idx_DEVICE_6                    :       (2 + (6*6)), 
    TransactLog_Idx_HOURS_6                     :       (3 + (6*6)), 
    TransactLog_Idx_SRC_6                       :       (4 + (6*6)), 
    TransactLog_Idx_PREV_6                      :       (5 + (6*6)), 
    TransactLog_Idx_CURR_6                      :       (6 + (6*6)), 
    TransactLog_Idx_TYPE_7                      :       (7 + (6*7)), 
    TransactLog_Idx_DEVICE_7                    :       (2 + (6*7)), 
    TransactLog_Idx_HOURS_7                     :       (3 + (6*7)), 
    TransactLog_Idx_SRC_7                       :       (4 + (6*7)), 
    TransactLog_Idx_PREV_7                      :       (5 + (6*7)), 
    TransactLog_Idx_CURR_7                      :       (6 + (6*7)), 
    TransactLog_Idx_TYPE_8                      :       (8 + (6*8)), 
    TransactLog_Idx_DEVICE_8                    :       (2 + (6*8)), 
    TransactLog_Idx_HOURS_8                     :       (3 + (6*8)), 
    TransactLog_Idx_SRC_8                       :       (4 + (6*8)), 
    TransactLog_Idx_PREV_8                      :       (5 + (6*8)), 
    TransactLog_Idx_CURR_8                      :       (6 + (6*8)), 
    TransactLog_Idx_TYPE_9                      :       (9 + (6*9)), 
    TransactLog_Idx_DEVICE_9                    :       (2 + (6*9)), 
    TransactLog_Idx_HOURS_9                     :       (3 + (6*9)), 
    TransactLog_Idx_SRC_9                       :       (4 + (6*9)), 
    TransactLog_Idx_PREV_9                      :       (5 + (6*9)), 
    TransactLog_Idx_CURR_9                      :       (6 + (6*9)), 
    FaultLog_Idx_DEVICE_0                       :       (61+ (3*0)), 
    FaultLog_Idx_TYPE_0                         :       (62+ (3*0)), 
    FaultLog_Idx_HOURS_0                        :       (63+ (3*0)), 
    FaultLog_Idx_DEVICE_1                       :       (61+ (3*1)), 
    FaultLog_Idx_TYPE_1                         :       (62+ (3*1)), 
    FaultLog_Idx_HOURS_1                        :       (63+ (3*1)), 
    FaultLog_Idx_DEVICE_2                       :       (61+ (3*2)), 
    FaultLog_Idx_TYPE_2                         :       (62+ (3*2)), 
    FaultLog_Idx_HOURS_2                        :       (63+ (3*2)), 
    FaultLog_Idx_DEVICE_3                       :       (61+ (3*3)), 
    FaultLog_Idx_TYPE_3                         :       (62+ (3*3)), 
    FaultLog_Idx_HOURS_3                        :       (63+ (3*3)), 
    FaultLog_Idx_DEVICE_4                       :       (61+ (3*4)), 
    FaultLog_Idx_TYPE_4                         :       (62+ (3*4)), 
    FaultLog_Idx_HOURS_4                        :       (63+ (3*4)), 
    FaultLog_Idx_DEVICE_5                       :       (61+ (3*5)), 
    FaultLog_Idx_TYPE_5                         :       (62+ (3*5)), 
    FaultLog_Idx_HOURS_5                        :       (63+ (3*5)), 
    FaultLog_Idx_DEVICE_6                       :       (61+ (3*6)), 
    FaultLog_Idx_TYPE_6                         :       (62+ (3*6)), 
    FaultLog_Idx_HOURS_6                        :       (63+ (3*6)), 
    FaultLog_Idx_DEVICE_7                       :       (61+ (3*7)), 
    FaultLog_Idx_TYPE_7                         :       (62+ (3*7)), 
    FaultLog_Idx_HOURS_7                        :       (63+ (3*7)), 
    FaultLog_Idx_DEVICE_8                       :       (61+ (3*8)), 
    FaultLog_Idx_TYPE_8                         :       (62+ (3*8)), 
    FaultLog_Idx_HOURS_8                        :       (63+ (3*8)), 
    FaultLog_Idx_DEVICE_9                       :       (61+ (3*9)), 
    FaultLog_Idx_TYPE_9                         :       (62+ (3*9)), 
    FaultLog_Idx_HOURS_9                        :       (63+ (3*9)), 

    NumItems                                    :       91,
};









var RxDataEnums_PG_TempSettings = 
{
    TemperatureZone_SetpointDegr_Idx_TANK       :       0,
    TemperatureZone_SetpointDegr_Idx_MANI       :       1,
    TemperatureZone_SetpointDegr_Idx_H1         :       2,
    TemperatureZone_SetpointDegr_Idx_G1         :       3,
    TemperatureZone_SetpointDegr_Idx_H2         :       4,
    TemperatureZone_SetpointDegr_Idx_G2         :       5,
    TemperatureZone_SetpointDegr_Idx_H3         :       6,
    TemperatureZone_SetpointDegr_Idx_G3         :       7,
    TemperatureZone_SetpointDegr_Idx_H4         :       8,
    TemperatureZone_SetpointDegr_Idx_G4         :       9,
    TemperatureZone_SetpointDegr_Idx_H5         :      10,
    TemperatureZone_SetpointDegr_Idx_G5         :      11,
    TemperatureZone_SetpointDegr_Idx_H6         :      12,
    TemperatureZone_SetpointDegr_Idx_G6         :      13,
    TemperatureZone_SetpointDegr_Idx_H7         :      14,
    TemperatureZone_SetpointDegr_Idx_G7         :      15,
    TemperatureZone_SetpointDegr_Idx_H8         :      16,
    TemperatureZone_SetpointDegr_Idx_G8         :      17,
    TemperatureUnits_Idx                        :      18,

    NumItems                                    :      19,
};


    








var RxDataEnums_PG_Clock = 
{                                        
    ClockSched_Idx_OnTime_1              :       0,
    ClockSched_Idx_OffTime_1             :       1,
    ClockSched_Idx_EnterStbyTime_1       :       2,
    ClockSched_Idx_ExitStdbyTime_1       :       3,
    ClockSched_Idx_OnTime_2              :       4,
    ClockSched_Idx_OffTime_2             :       5,
    ClockSched_Idx_EnterStdbyTime_2      :       6,
    ClockSched_Idx_ExitStdbyTime_2       :       7,
    ClockSched_Idx_OnTime_3              :       8,
    ClockSched_Idx_OffTime_3             :       9,
    ClockSched_Idx_EnterStbyTime_3       :      10,
    ClockSched_Idx_ExitStdbyTime_3       :      11,
    ClockSched_Idx_MON                   :      12,
    ClockSched_Idx_TUE                   :      13,
    ClockSched_Idx_WED                   :      14,
    ClockSched_Idx_THU                   :      15,
    ClockSched_Idx_FRI                   :      16,
    ClockSched_Idx_SAT                   :      17,
    ClockSched_Idx_SUN                   :      18,
    Clock_D_Idx                          :      19,
    Clock_H_Idx                          :      20,
    Clock_M_Idx                          :      21,

    NumItems                             :      22,
};



var RxDataEnums_PG_AdhUsage = 
{
    BlueSeriesDevPresent_BITMASK_Idx        :       0,
                                            
    FlowMeterUsingEnglishUnits_Idx          :       1,
    FlowMeterAvgAdhPerHr_grams_Idx          :       2,
    FlowMeterAvgAdhPerTrig_mg_Idx           :       3,
    FlowMeterAdhVolume_grams_Idx            :       4,
    FlowMeterAdhVolume_TrigCount_Idx        :       5,
    FlowMeterAdhVolume_AlertMask_Idx        :       6,
    FlowMeterAdhVolume_WarningCount_Idx     :       7,
    FlowMeterAdhVolume_DefectCount_Idx      :       8,
                                            
    FlowMeterAdhVolume_TargetAddOn_mg_Idx   :       9,
    FlowMeterAdhVolume_TargetKFact_100th_Idx:      10,
    FlowMeterAdhVolume_TrigPolarity_Idx     :      11,
    FlowMeterAdhVolume_TargetSpGr_100th_Idx :      12,
    FlowMeterAdhVolume_SkipCount_Idx        :      13,
    FlowMeterAdhVolume_SkipTime_secs_Idx    :      14,
    FlowMeterAdhVolume_AvgCount_Idx         :      15,
    FlowMeterAdhVolume_LearnCount_Idx       :      16,
    FlowMeterAdhVolume_WarnDelay_secs_Idx   :      17,
                                                   
    FlowMeterAdhVolume_OperMode_Idx         :      18,

    FlowMeterAdhVolume_LOPercent_Idx        :      19,
    FlowMeterAdhVolume_HIPercent_Idx        :      20,

    NumItems                                :      21,
};






var RxDataEnums_PG_SystemInfo = 
{
    MelterSwVer_Idx                         :       0,

    NumItems                                :       1,
};





var RxDataUnitInfo = 
{                                        
    Name_Idx                           :      0,
    Location_Idx                       :      1,
    NumItems                           :      2,
};




var BlueSeriesDevPresentMask = 
{
    CeBlueSeriesDevPresentMask_78HG    :      0,
    CeBlueSeriesDevPresentMask_Refill  :      1,     
    CeBlueSeriesDevPresentMask_AdhMeter:      2,
    CeBlueSeriesDevPresentMask_NOTUSED :      3,
    CeBlueSeriesDevPresentMask_Motor1  :      4,
    CeBlueSeriesDevPresentMask_Motor2  :      5,
    CeBlueSeriesDevPresentMask_Motor3  :      6, 
    CeBlueSeriesDevPresentMask_Motor4  :      7
};




var DayOfWeekARR =          // mjp::todo uugghh!  CSS class rows_new_white_sm seems to wrap Wednesday + time [it's too long for one line], so abbrev and leave for layout 
[
    "Mon",
    "Tues",
    "Wed",
    "Thurs",
    "Fri",
    "Sat",
    "Sun"
];







function zeroPad(num, places) 
{
    var zero = places - num.toString().length + 1;
    return Array(+(zero > 0 && zero)).join("0") + num;
}




function displAdhParam( theParam, bParamIn_mg, bUsingEngUnits )         // param always provided in function of either mg or grams units
{
    var myVal;
    var myUnits;


    if( !bUsingEngUnits )
    {
        if( bParamIn_mg )
        {
            if(      theParam < 1000 )
            {
                myVal   = theParam;
                myUnits = "mg";
            }
            else if( theParam < 1000000 )
            {
                myVal   = theParam/1000;
                myVal   = myVal.toFixed(3);
                myUnits = "g";
            }
            else 
            {
                myVal   = theParam/1000;
                myVal   = myVal.toFixed(3);
                myUnits = "kg";
            }
        }
        else
        {
            if(      theParam < 1000 )
            {
                myVal   = theParam;
                myUnits = "g";
            }
            else 
            {
                myVal   = theParam/1000;
                myVal   = myVal.toFixed(3);
                myUnits = "kg";
            }
        }
    }
    else
    {
        myVal = theParam * 0.035274;          // g to oz
        
        if( bParamIn_mg )
        {
            myVal = myVal / 1000;
        }

        if( myVal < 100 )
        {
            myVal   = myVal.toFixed(3);
            myUnits = "oz";
        }
        else
        {
            myVal   = myVal / 16;
            myVal   = myVal.toFixed(3);
            myUnits = "lb";
        }
    }

    return { v:myVal, u:myUnits };
}


